Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkRIBExporter Class Reference

`#include <vtkRIBExporter.h>`

Inheritance diagram for vtkRIBExporter:

[legend]
Collaboration diagram for vtkRIBExporter:

[legend]
List of all members.

## Detailed Description

export a scene into RenderMan RIB format.

Date:
  2002/06/04 02:21:52

Revision:
  1.22

vtkRIBExporter is a concrete subclass of vtkExporter that writes a Renderman .RIB files. The input specifies a vtkRenderWindow. All visible actors and lights will be included in the rib file. The following file naming conventions apply: rib file - FilePrefix.rib image file created by RenderMan - FilePrefix.tif texture files - TexturePrefix_0xADDR_MTIME.tif This object does NOT generate an image file. The user must run either RenderMan or a RenderMan emulator like Blue Moon Ray Tracer (BMRT). vtk properties are convert to Renderman shaders as follows: Normal property, no texture map - plastic.sl Normal property with texture map - txtplastic.sl These two shaders must be compiled by the rendering package being used. vtkRIBExporter also supports custom shaders. The shaders are written using the Renderman Shading Language. See "The Renderman Companion", ISBN 0-201-50868, 1989 for details on writing shaders. vtkRIBProperty specifies the declarations and parameter settings for custom shaders. Tcl Example: generate a rib file for the current rendering. vtkRIBExporter myRIB myRIB SetInput $renWin myRIB SetFIlePrefix mine myRIB Write This will create a file mine.rib. After running this file through a Renderman renderer a file mine.tif will contain the rendered image.

See also:
  vtkExporter vtkRIBProperty

Created by:
  - Martin, Ken

CVS contributions (if > 5%):
  - Martin, Ken (44%)
  - Schroeder, Will (22%)
  - Cedilnik, Andy (21%)
  - Lorensen, Bill (8%)

CVS logs (CVSweb):
  - .`h` (`/Hybrid/vtkRIBExporter.h)`
  - .`cxx` (`/Hybrid/vtkRIBExporter.cxx)`

Tests:
  vtkRIBExporter (Tests)

Definition at line 82 of file vtkRIBExporter.h.

## Public Types
typedef vtkExporter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetSize (int, int)
void | SetSize (int[2])
virtual int * | GetSize ()
virtual void | GetSize (int data[2])
virtual void | SetPixelSamples (int, int)
void | SetPixelSamples (int[2])
virtual int * | GetPixelSamples ()
virtual void | GetPixelSamples (int data[2])
virtual void | SetFilePrefix (const char *)
virtual char * | GetFilePrefix ()
virtual void | SetTexturePrefix (const char *)
virtual char * | GetTexturePrefix ()
virtual void | SetBackground (int)
virtual int | GetBackground ()
virtual void | BackgroundOn ()
virtual void | BackgroundOff ()
virtual void | SetExportArrays (int)
virtual void | ExportArraysOn ()
virtual void | ExportArraysOff ()
virtual int | GetExportArrays ()
## Static Public Methods
vtkRIBExporter * | New ()
int | IsTypeOf (const char *type)
vtkRIBExporter * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkRIBExporter ()
| ~vtkRIBExporter ()
void | WriteData ()
void | WriteActor (vtkActor *anActor)
void | ModifyArrayName (char *newname, const char *name)
char * | GetTextureName (vtkTexture *aTexture)
char * | GetTIFFName (vtkTexture *aTexture)
void | WriteHeader (vtkRenderer *aRen)
void | WriteTrailer ()
void | WriteTexture (vtkTexture *aTexture)
void | WriteViewport (vtkRenderer *aRenderer, int size[2])
void | WriteCamera (vtkCamera *aCamera)
void | WriteLight (vtkLight *aLight, int count)
void | WriteAmbientLight (int count)
void | WriteProperty (vtkProperty *aProperty, vtkTexture *aTexture)
void | WritePolygons (vtkPolyData *pd, vtkUnsignedCharArray *colors, vtkProperty *aProperty)
void | WriteStrips (vtkPolyData *pd, vtkUnsignedCharArray *colors, vtkProperty *aProperty)
## Protected Attributes
int | Background
int | Size [2]
int | PixelSamples [2]
int | ExportArrays
char * | FilePrefix
FILE * | FilePtr
char * | TexturePrefix

## Member Typedef Documentation

typedef vtkExporter vtkRIBExporter::Superclass

| Reimplemented from vtkExporter. Definition at line 86 of file vtkRIBExporter.h.

## Constructor & Destructor Documentation

vtkRIBExporter::vtkRIBExporter | ( |  | ) | `[protected]`

vtkRIBExporter::~vtkRIBExporter | ( |  | ) | `[protected]`

## Member Function Documentation

vtkRIBExporter* vtkRIBExporter::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkRIBExporter::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkExporter.

int vtkRIBExporter::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkExporter.

virtual int vtkRIBExporter::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkExporter.

vtkRIBExporter* vtkRIBExporter::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkExporter.

void vtkRIBExporter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkExporter.

virtual void vtkRIBExporter::SetSize | ( | int | ,
|  | int |
| ) | `[virtual]`

| Specify the size of the image for RenderMan. If none is specified, the size of the render window will be used.

void vtkRIBExporter::SetSize | ( | int | [2] | ) |

| Specify the size of the image for RenderMan. If none is specified, the size of the render window will be used.

virtual int* vtkRIBExporter::GetSize | ( |  | ) | `[virtual]`

| Specify the size of the image for RenderMan. If none is specified, the size of the render window will be used.

virtual void vtkRIBExporter::GetSize | ( | int | data[2] | ) | `[virtual]`

| Specify the size of the image for RenderMan. If none is specified, the size of the render window will be used.

virtual void vtkRIBExporter::SetPixelSamples | ( | int | ,
|  | int |
| ) | `[virtual]`

| Specify the sampling rate for the rendering. Default is 2 2.

void vtkRIBExporter::SetPixelSamples | ( | int | [2] | ) |

| Specify the sampling rate for the rendering. Default is 2 2.

virtual int* vtkRIBExporter::GetPixelSamples | ( |  | ) | `[virtual]`

| Specify the sampling rate for the rendering. Default is 2 2.

virtual void vtkRIBExporter::GetPixelSamples | ( | int | data[2] | ) | `[virtual]`

| Specify the sampling rate for the rendering. Default is 2 2.

virtual void vtkRIBExporter::SetFilePrefix | ( | const char * |  | ) | `[virtual]`

| Specify the prefix of the files to write out. The resulting file names will have .RIB appended to them.

virtual char* vtkRIBExporter::GetFilePrefix | ( |  | ) | `[virtual]`

| Specify the prefix of the files to write out. The resulting file names will have .RIB appended to them.

virtual void vtkRIBExporter::SetTexturePrefix | ( | const char * |  | ) | `[virtual]`

| Specify the prefix of any generated texture files.

virtual char* vtkRIBExporter::GetTexturePrefix | ( |  | ) | `[virtual]`

| Specify the prefix of any generated texture files.

virtual void vtkRIBExporter::SetBackground | ( | int |  | ) | `[virtual]`

| Set/Get the background flag. Default is 0 (off). If set, the rib file will contain an image shader that will use the renderer window's background color. Normally, RenderMan does generate backgrounds. Backgrounds are composited into the scene with the tiffcomp program that comes with Pixar's RenderMan Toolkit. In fact, Pixar's Renderman will accept an image shader but only sets the alpha of the background. Images created this way will still have a black background but contain an alpha of 1 at all pixels and CANNOT be subsequently composited with other images using tiffcomp. However, other RenderMan compliant renderers like Blue Moon Ray Tracing (BMRT) do allow image shaders and properly set the background color. If this sounds too confusing, use the following rules: If you are using Pixar's Renderman, leave the Background off. Otherwise, try setting BackGroundOn and see if you get the desired results.

virtual int vtkRIBExporter::GetBackground | ( |  | ) | `[virtual]`

| Set/Get the background flag. Default is 0 (off). If set, the rib file will contain an image shader that will use the renderer window's background color. Normally, RenderMan does generate backgrounds. Backgrounds are composited into the scene with the tiffcomp program that comes with Pixar's RenderMan Toolkit. In fact, Pixar's Renderman will accept an image shader but only sets the alpha of the background. Images created this way will still have a black background but contain an alpha of 1 at all pixels and CANNOT be subsequently composited with other images using tiffcomp. However, other RenderMan compliant renderers like Blue Moon Ray Tracing (BMRT) do allow image shaders and properly set the background color. If this sounds too confusing, use the following rules: If you are using Pixar's Renderman, leave the Background off. Otherwise, try setting BackGroundOn and see if you get the desired results.

virtual void vtkRIBExporter::BackgroundOn | ( |  | ) | `[virtual]`

| Set/Get the background flag. Default is 0 (off). If set, the rib file will contain an image shader that will use the renderer window's background color. Normally, RenderMan does generate backgrounds. Backgrounds are composited into the scene with the tiffcomp program that comes with Pixar's RenderMan Toolkit. In fact, Pixar's Renderman will accept an image shader but only sets the alpha of the background. Images created this way will still have a black background but contain an alpha of 1 at all pixels and CANNOT be subsequently composited with other images using tiffcomp. However, other RenderMan compliant renderers like Blue Moon Ray Tracing (BMRT) do allow image shaders and properly set the background color. If this sounds too confusing, use the following rules: If you are using Pixar's Renderman, leave the Background off. Otherwise, try setting BackGroundOn and see if you get the desired results.

virtual void vtkRIBExporter::BackgroundOff | ( |  | ) | `[virtual]`

| Set/Get the background flag. Default is 0 (off). If set, the rib file will contain an image shader that will use the renderer window's background color. Normally, RenderMan does generate backgrounds. Backgrounds are composited into the scene with the tiffcomp program that comes with Pixar's RenderMan Toolkit. In fact, Pixar's Renderman will accept an image shader but only sets the alpha of the background. Images created this way will still have a black background but contain an alpha of 1 at all pixels and CANNOT be subsequently composited with other images using tiffcomp. However, other RenderMan compliant renderers like Blue Moon Ray Tracing (BMRT) do allow image shaders and properly set the background color. If this sounds too confusing, use the following rules: If you are using Pixar's Renderman, leave the Background off. Otherwise, try setting BackGroundOn and see if you get the desired results.

virtual void vtkRIBExporter::SetExportArrays | ( | int |  | ) | `[virtual]`

| Set or get the ExportArrays. If ExportArrays is set, then all point data, field data, and cell data arrays will get exported together with polygons.

virtual void vtkRIBExporter::ExportArraysOn | ( |  | ) | `[virtual]`

| Set or get the ExportArrays. If ExportArrays is set, then all point data, field data, and cell data arrays will get exported together with polygons.

virtual void vtkRIBExporter::ExportArraysOff | ( |  | ) | `[virtual]`

| Set or get the ExportArrays. If ExportArrays is set, then all point data, field data, and cell data arrays will get exported together with polygons.

virtual int vtkRIBExporter::GetExportArrays | ( |  | ) | `[virtual]`

| Set or get the ExportArrays. If ExportArrays is set, then all point data, field data, and cell data arrays will get exported together with polygons.

void vtkRIBExporter::WriteHeader | ( | vtkRenderer * | aRen | ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteTrailer | ( |  | ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteTexture | ( | vtkTexture * | aTexture | ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteViewport | ( | vtkRenderer * | aRenderer,
|  | int | size[2]
| ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteCamera | ( | vtkCamera * | aCamera | ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteLight | ( | vtkLight * | aLight,
|  | int | count
| ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteAmbientLight | ( | int | count | ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteProperty | ( | vtkProperty * | aProperty,
|  | vtkTexture * | aTexture
| ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WritePolygons | ( | vtkPolyData * | pd,
|  | vtkUnsignedCharArray * | colors,
|  | vtkProperty * | aProperty
| ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteStrips | ( | vtkPolyData * | pd,
|  | vtkUnsignedCharArray * | colors,
|  | vtkProperty * | aProperty
| ) | `[protected]`

| Write the RIB header.

void vtkRIBExporter::WriteData | ( |  | ) | `[protected, virtual]`

| Implements vtkExporter.

void vtkRIBExporter::WriteActor | ( | vtkActor * | anActor | ) | `[protected]`

void vtkRIBExporter::ModifyArrayName | ( | char * | newname,
|  | const char * | name
| ) | `[protected]`

| Since additional variables are sent to the shader as variables, and their names are used in the shader, these names have to follow C naming convention. This method modifies array name so that you can use it in shader.

char* vtkRIBExporter::GetTextureName | ( | vtkTexture * | aTexture | ) | `[protected]`

char* vtkRIBExporter::GetTIFFName | ( | vtkTexture * | aTexture | ) | `[protected]`

## Member Data Documentation

int vtkRIBExporter::Background`[protected]`

| Definition at line 148 of file vtkRIBExporter.h.

int vtkRIBExporter::Size[2]`[protected]`

| Definition at line 149 of file vtkRIBExporter.h.

int vtkRIBExporter::PixelSamples[2]`[protected]`

| Definition at line 150 of file vtkRIBExporter.h.

int vtkRIBExporter::ExportArrays`[protected]`

| This variable defines whether the arrays are exported or not. Definition at line 153 of file vtkRIBExporter.h.

char* vtkRIBExporter::FilePrefix`[protected]`

| Definition at line 182 of file vtkRIBExporter.h.

FILE* vtkRIBExporter::FilePtr`[protected]`

| Definition at line 183 of file vtkRIBExporter.h.

char* vtkRIBExporter::TexturePrefix`[protected]`

| Definition at line 184 of file vtkRIBExporter.h.

The documentation for this class was generated from the following file:

- Hybrid/vtkRIBExporter.h